package ezreader10;

import java.io.PrintStream;
import java.util.*;

class Display {
    
    //**************************************************************************
    
    void classMeans(PrintStream diskWriter, ArrayList<Word> classMeans, double RMSD, double PrReg) {
/*        
        // Initialize observed means and standard deviations (based on Schilling et al., 1998):
        double[] obsMeanFFD = new double[] { 251, 239, 237, 233, 216 }; 
        double[] obsMeanSFD = new double[] { 264, 248, 243, 237, 216 };
        double[] obsMeanGD = new double[] { 308, 278, 265, 241, 222 }; 
        double[] obsMeanPr1 = new double[] { 0.67, 0.70, 0.68, 0.44, 0.31 }; 
        double[] obsMeanPr2 = new double[] { 0.23, 0.18, 0.10, 0.02, 0.01 };
        double[] obsMeanPrS = new double[] { 0.10, 0.12, 0.22, 0.54, 0.67 };  
*/
        // Initialize observed means and standard deviations (based on Schilling et al., 1998):
        double[] obsMeanFFD = new double[] { 274, 237, 243, 246, 238, 242, 224, 205 }; 
        double[] obsMeanSFD = new double[] { 281, 257, 253, 260, 246, 246, 228, 204 }; 
        double[] obsMeanGD = new double[] { 336, 284, 304, 301, 266, 260, 235, 209 }; 
        double[] obsMeanPr1 = new double[] { 0.725, 0.655, 0.695, 0.669, 0.714, 0.575, 0.373, 0.311 }; 
        double[] obsMeanPr2 = new double[] { 0.203, 0.177, 0.254, 0.223, 0.128, 0.053, 0.025, 0.008 }; 
        double[] obsMeanPrS = new double[] { 0.071, 0.167, 0.051, 0.108, 0.158, 0.372, 0.601, 0.681 };  
        
        // Display frequency class means:
        diskWriter.printf(" f    FFD      SFD       GD       Pr1        Pr2        PrS\n");
        diskWriter.printf(" -  -------  -------  -------  ---------  ---------  ---------\n");
        for (int i = 0; i < EZReader10.NFreqClass; i++) {
            diskWriter.printf(" %1d  %3.0f %3.0f  %3.0f %3.0f  %3.0f %3.0f  %4.2f %4.2f  %4.2f %4.2f  %4.2f %4.2f\n", i + 1, 
                    obsMeanFFD[i], classMeans.get(i).dv.FFD, 
                    obsMeanSFD[i], classMeans.get(i).dv.SFD, 
                    obsMeanGD[i], classMeans.get(i).dv.GD,
                    obsMeanPr1[i], classMeans.get(i).dv.Pr1, 
                    obsMeanPr2[i], classMeans.get(i).dv.Pr2, 
                    obsMeanPrS[i], classMeans.get(i).dv.PrS);
        }

        diskWriter.println();
        diskWriter.printf(" RMSD %6.4f PrReg %6.4f\n\n", RMSD, PrReg);  
    }
    
    //**************************************************************************
    
    void corpus(PrintStream diskWriter, ArrayList<Sentence> text) {
        
        for (int i = 0; i < EZReader10.NSentences; i++) {
            diskWriter.printf(" Sentence %2d\n", i);
            for (int j = 0; j < text.get(i).numberWords; j++) {             
                diskWriter.printf(" %15.0f %4.2f %2.0f %3.0f %4.1f %3.0f" + 
                        text.get(i).get(j).iv.letters, 
                        text.get(i).get(j).iv.freq, 
                        text.get(i).get(j).iv.cloze,
                        text.get(i).get(j).iv.length, 
                        text.get(i).get(j).iv.pos0, 
                        text.get(i).get(j).iv.OVP, 
                        text.get(i).get(j).iv.posN);
                if (j == text.get(i).target) diskWriter.printf(" *"); // target
                diskWriter.println();
            }
        }
    }
    
    //**************************************************************************
     
    void fixDists(PrintStream diskWriter, ArrayList<Sentence> text) {   
        
        diskWriter.println();
        diskWriter.printf(" First-fixation landing-site distributions:\n");
        for (int S = 0; S < EZReader10.NSentences; S++) {
            for (int j = 1; j < text.get(S).numberWords - 1; j++) {   
                for (int k = 0; k <= text.get(S).get(j).iv.length; k++) diskWriter.printf(" %3.2f", text.get(S).get(j).dv.FixDist[k]);
                diskWriter.printf(" " + text.get(S).get(j).iv.letters);
                if (j == text.get(S).target) diskWriter.printf(" *"); // target
                diskWriter.println();
            }
        }
    }
 
    //**************************************************************************
    
    void IOVPs(PrintStream diskWriter, ArrayList<Sentence> text) { 
        
        diskWriter.println();
        diskWriter.printf(" IOVP distributions:\n");
        for (int S = 0; S < EZReader10.NSentences; S++) {
            for (int j = 1; j < text.get(S).numberWords - 1; j++) {
                for (int k = 0; k <= text.get(S).get(j).iv.length; k++) diskWriter.printf(" %4.0f", text.get(S).get(j).dv.IOVP[k]);
                diskWriter.printf(" " + text.get(S).get(j).iv.letters);
                if (j == text.get(S).target) diskWriter.printf(" *"); // target
                diskWriter.println();
            }
        }
    }

    //**************************************************************************
     
    void means(PrintStream diskWriter, ArrayList<Sentence> text) {
            
        diskWriter.println();
        diskWriter.printf(" Word-based means:\n");
        for (int i = 0; i < EZReader10.NSentences; i++) {       
            for (int j = 1; j < text.get(i).numberWords - 1; j++) {
                diskWriter.printf(" SFD %3.0f ", text.get(i).get(j).dv.SFD);
                diskWriter.printf(" FFD %3.0f ", text.get(i).get(j).dv.FFD);
                diskWriter.printf(" GD %3.0f ", text.get(i).get(j).dv.GD);
                diskWriter.printf(" TT %3.0f ", text.get(i).get(j).dv.TT);
                diskWriter.printf(" PrF %3.2f", text.get(i).get(j).dv.PrF);
                diskWriter.printf(" Pr1 %3.2f", text.get(i).get(j).dv.Pr1);
                diskWriter.printf(" Pr2 %3.2f", text.get(i).get(j).dv.Pr2);
                diskWriter.printf(" PrS %3.2f" + text.get(i).get(j).iv.letters, text.get(i).get(j).dv.PrS);
                if (j == text.get(i).target) diskWriter.printf(" *"); // target
                diskWriter.println();
            }
        }  
    }
     
    //**************************************************************************
     
    void meanFixDists(PrintStream diskWriter, ArrayList<Word> fixDists) {
        
        diskWriter.println();
        diskWriter.printf(" First-fixation landing-site distributions:\n");
        for (int i = 1; i < EZReader10.maxLength; i++) {
            diskWriter.printf(" %2d-letter: ", i);
            for (int j = 0; j <= i; j++) diskWriter.printf(" %4.2f", fixDists.get(i).dv.FixDist[j]);
            diskWriter.println();
        }
        diskWriter.println();
    }
    
    //**************************************************************************
    
    void meanIOVPs(PrintStream diskWriter, ArrayList<Word> IOVPs) {
        
        diskWriter.println();
        diskWriter.printf(" IOVP distributions:\n");
        for (int i = 1; i < EZReader10.maxLength; i++) {
            diskWriter.printf(" %2d-letter: ", i);
            for (int j = 0; j <= i; j++) diskWriter.printf(" %4.0f", IOVPs.get(i).dv.IOVP[j]);
            diskWriter.println();
        }
        diskWriter.println();
    }
    
    //**************************************************************************
    
    void meanRefixProbs(PrintStream diskWriter, ArrayList<Word> fixDists) {
            
        diskWriter.println();
        diskWriter.printf(" Refixation probability distributions:\n");
        for (int i = 1; i < EZReader10.maxLength; i++) {
            diskWriter.printf(" %2d-letter: ", i);
            for (int j = 0; j <= i; j++) diskWriter.printf(" %4.2f", fixDists.get(i).dv.RefixProb[j]);
            diskWriter.println();
        }
        diskWriter.println();
    }

    //**************************************************************************
    
    public void parameters(PrintStream diskWriter) {
        
        diskWriter.printf("\n Parameter values:\n");
        diskWriter.printf(" A = %3.2f\n", EZReader10.A);
        diskWriter.printf(" Alpha1 = %3.2f\n", EZReader10.Alpha1);
        diskWriter.printf(" Alpha2 = %3.2f\n", EZReader10.Alpha2);
        diskWriter.printf(" Alpha3 = %3.2f\n", EZReader10.Alpha3);
        diskWriter.printf(" Delta = %3.2f\n", EZReader10.Delta);
        diskWriter.printf(" Epsilon = %3.2f\n", EZReader10.Epsilon);
        diskWriter.printf(" Eta1 = %3.2f\n", EZReader10.Eta1);
        diskWriter.printf(" Eta2 = %3.2f\n", EZReader10.Eta2);
        diskWriter.printf(" I = %3.2f\n", EZReader10.I);
        diskWriter.printf(" ITarget = %3.2f\n", EZReader10.ITarget);
        diskWriter.printf(" Lambda = %3.2f\n", EZReader10.Lambda);
        diskWriter.printf(" M1 = %3.2f\n", EZReader10.M1);
        diskWriter.printf(" M2 = %3.2f\n", EZReader10.M2);
        diskWriter.printf(" Omega1 = %3.2f\n", EZReader10.Omega1);
        diskWriter.printf(" Omega2 = %3.2f\n", EZReader10.Omega2);
        diskWriter.printf(" pF = %3.2f\n", EZReader10.pF);
        diskWriter.printf(" pFTarget = %3.2f\n", EZReader10.pFTarget);
        diskWriter.printf(" Psi = %3.2f\n", EZReader10.Psi);
        diskWriter.printf(" S = %3.2f\n", EZReader10.S);
        diskWriter.printf(" SigmaGamma = %3.2f\n", EZReader10.SigmaGamma);
        diskWriter.printf(" V = %3.2f\n", EZReader10.V);
        diskWriter.printf(" Xi = %3.2f\n\n", EZReader10.Xi);
        diskWriter.printf(" NSubjects = %1d\n\n", EZReader10.NSubjects);
    }
    
    //**************************************************************************
    
    void refixProbs(PrintStream diskWriter, ArrayList<Sentence> text) { 
        
        diskWriter.println();
        diskWriter.printf(" Refixation probability distributions:\n");
        for (int S = 0; S < EZReader10.NSentences; S++) {
            for (int j = 1; j < text.get(S).numberWords - 1; j++) {
                for (int k = 0; k <= text.get(S).get(j).iv.length; k++) diskWriter.printf(" %3.2f", text.get(S).get(j).dv.RefixProb[k]);
                diskWriter.printf(" " + text.get(S).get(j).iv.letters);
                if (j == text.get(S).target) diskWriter.printf(" *"); // target
                diskWriter.println();
            }
        }
    }

    //**************************************************************************
     
    void trace(PrintStream diskWriter, ArrayList<Sentence> text, int S, ArrayList<Fixation> trace) {
        
        for (int i = 0; i < trace.size(); i++) {
            diskWriter.printf(" dur: %3.0f pos: %4.1f word: %2d ", trace.get(i).dur, trace.get(i).pos, trace.get(i).word);
            diskWriter.printf(text.get(S).get(trace.get(i).word).iv.letters);
            diskWriter.println();
        }
    }
}

//******************************************************************************

